/* 
	Poenostavljen problem petih filozofov, petih kroznikov spagetov in petih vilic
		
	Za okroglo mizo zboruje pet filozofov, ki v vec ciklih razmisljajo, so lacni, jejo, 
	potem spet razmisljajo, ... Jedo spagete, ki jih ima vsak na svojem krozniku. Pri jedi
	spagetov potrebuje vsak dvoje vilice, ki pa jih imajo skupaj na voljo samo pet! 

	samo en filozof na enkrat lahko vzame vilice - smrtni objem ni več možen	
*/
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <windows.h>
#include <pthread.h> 

#define FILOZOFOV 5
#define JEDI 50

void *zborovanje(void *);

pthread_mutex_t mutex_vilice[5];
pthread_mutex_t mutex_prijemanje_vilic;
 
int main(void)  
{
	int i;
	int filozof[FILOZOFOV];
	pthread_t thread_filozof[FILOZOFOV]; 

	pthread_mutex_init(&mutex_prijemanje_vilic, NULL);
	for (i=0; i<FILOZOFOV; i++)
		pthread_mutex_init(&mutex_vilice[i], NULL);

	for (i=0; i<FILOZOFOV; i++)
	{
		filozof[i] = i;
		pthread_create(&thread_filozof[i], NULL, zborovanje, &filozof[i]);
	}

	for (i=0; i<FILOZOFOV; i++)
		pthread_join(thread_filozof[i],NULL);

	return( 0 );
}

void *zborovanje(void *par)
{
	int f;
	int jed = 0;

	f = *(int *)par;
	printf("Filozof %d je prisedel.\n", f);

	while (jed < JEDI) 
	{
		printf("Filozof %d razmislja.\n", f);
		Sleep(f);
		printf("Filozof %d je lacen.\n", f);
		pthread_mutex_lock(&mutex_prijemanje_vilic);
		pthread_mutex_lock(&mutex_vilice[f]);
		Sleep(f);
		pthread_mutex_lock(&mutex_vilice[(f+1)%FILOZOFOV]);
		pthread_mutex_unlock(&mutex_prijemanje_vilic);
		printf("Filozof %d je jed %d.\n", f, jed);
		jed++;
		Sleep(f);
		printf("Filozof %d je nehal jesti jed %d.\n", f, jed);
		pthread_mutex_unlock(&mutex_vilice[f]);
		pthread_mutex_unlock(&mutex_vilice[(f+1)%FILOZOFOV]);
	}

	return(NULL);
}
